
/** ------ effect state ------- **/

var rot = 1.0;

var testMorphingStr = 0;
var isGoingUp = true;

if (!Object.keys) {
    Object.keys = function (obj) {
        var keys = [],
            k;
        for (k in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, k)) {
                keys.push(k);
            }
        }
        return keys;
    };
}

Array.prototype.includes||Object.defineProperty(Array.prototype,"includes",{value:function(r,e){if(null==this)throw new TypeError('"this" is null or not defined');var t=Object(this),n=t.length>>>0;if(0===n)return!1;var i,o,a=0|e,u=Math.max(0<=a?a:n-Math.abs(a),0);for(;u<n;){if((i=t[u])===(o=r)||"number"==typeof i&&"number"==typeof o&&isNaN(i)&&isNaN(o))return!0;u++}return!1}});

var effectData = {
    reservedMeshId: {
        retouch: 0,
        bgSeparationMesh: 7,
    },

    meshes: {
        retouch : "!glfx_FACE",
        bgSeparation: "triBG2.bsm2",
    },

    faceTrackerData: {
      active: false
    },

    shadersIDs: {
        softlightAlpha: 0,
        angle: 1,
        makeupApply: 2,
        sliderPos: 3,
        faceTracker: 6,
        bgRotation: 8,
        bgScale: 9,
        platformData: 10,
        makeupType: 15,
    },

    retouchTexturesIDs: {
        softLight: 0,
        makeup: 1
    },

    meshesState: {
        bgSeparationCreated: false,
    },

    recognizerData: {
        initializedRecognizers: {
            bg: false,
        },
        
        activeRecognizers: [ ]
    },

    makeupsData: {
        isInitialized: false,
        makeups: { // makeups[id][0] - texture name, makeups[id][1] - texture type (0 - half, 1 - full).
            "Empty": { type: 0, tex_name: "MakeupNull.png" },
            "Iris": { type: 0, tex_name: "makeup_iris.png" },
            "Azalea": { type: 0, tex_name: "makeup_arrows.png" },
            "Hibiscus": { type: 0, tex_name: "makeup_smokey.png" },
            "Geranium": { type: 0, tex_name: "makeup_redarrows.png" },
            "Aster": { type: 0, tex_name: "makeup_nude.png" },
            "Freesia": { type: 0, tex_name: "makeup_yellow.png" },
            "Carnation": { type: 0, tex_name: "makeup_purplepink.png" },
            "Begonia": { type: 0, tex_name: "makeup_split2.png" },
            "Jasmine": { type: 0, tex_name: "makeup_nude2.png" },
            "Daisy": { type: 0, tex_name: "makeup_violet.png" },
            "Tulip": { type: 0, tex_name: "makeup_3Bridal2.png" },
            "Sunset": { type: 0, tex_name: "makeup_4Bridal3.png" },
            "Smoky": { type: 0, tex_name: "makeup_10smokey.png" },
            "Femme": { type: 0, tex_name: "makeup_Celebrity1.png" },
            "Romp": { type: 0, tex_name: "makeup_Celebrity2.png" },
            "Hush": { type: 0, tex_name: "makeup_Celebrity3.png" },
            "Brun": { type: 0, tex_name: "makeup_Evening1.png" },
            "Icon": { type: 0, tex_name: "makeup_Evening2.png" },
            "Crocus": { type: 0, tex_name: "makeup_Evening3.png" },
            "Malt": { type: 0, tex_name: "makeup_Metallic1.png" },
            "Kid": { type: 0, tex_name: "makeup_Metallic2.png" },
            "Bluebell": { type: 0, tex_name: "makeup_Metallic3.png" },
            "Foxy": { type: 0, tex_name: "makeup_Cat1.png" },
            "Swan": { type: 0, tex_name: "makeup_Cat2.png" },
            "Dreamy": { type: 0, tex_name: "makeup_Cat3.png" },
            "Galaxy": { type: 0, tex_name: "makeup_Color_Makeup1.png" },
            "Elf": { type: 0, tex_name: "makeup_Color_Makeup2.png" },
            "Gloom": { type: 0, tex_name: "makeup_Color_Makeup3.png" },
            "Elegant": { type: 0, tex_name: "makeup_Creative_Lines1.png" },
            "Feast": { type: 0, tex_name: "makeup_Creative_Lines2.png" },
            "40s": { type: 0, tex_name: "makeup_Creative_Lines3.png" },
            "Coral": { type: 0, tex_name: "makeup_Gothic1.png" },
            "Mermaid": { type: 0, tex_name: "makeup_Mermaid1.png" },
            "Fresh": { type: 0, tex_name: "makeup_Nude1.png" },
            "Cleo": { type: 0, tex_name: "makeup_Office1.png" },
            "Dusk": { type: 0, tex_name: "makeup_Office2.png" },
            "Stylish": { type: 0, tex_name: "makeup_Rock_Star1.png" },
            "Lotus": { type: 0, tex_name: "makeup_Rock_Star2.png" },
            "Hippie": { type: 0, tex_name: "makeup_Rock_Star3.png" },
            "Glitz": { type: 0, tex_name: "makeup_Rockstar1.png" },
            "Doll": { type: 0, tex_name: "makeup_Smokey1.png" },
            "Dawn": { type: 0, tex_name: "makeup_smokey2.png" },
            "Glam": { type: 0, tex_name: "makeup_Smokey3.png" },
            "Homediva": { type: 1, tex_name: "makeup_stayhome.png" },
            "Lady-19": { type: 1, tex_name: "makeup_staysafe.png" },
            "Easter": { type: 1, tex_name: "makeup_easter.png" },
        }
    },

    faceFrameData: {
        isInitialized: false
    },

    bgState: {
        lastAngle: 0,
        currAngle: 0,
        lastScale: 0,
        currScale: 1,
    },

    interpolation: {
        morph_cheeks_str: {
            "0.0": 0.0,
            "0.4": 0.3,
            "0.8": 0.8,
            "1.0": 1.0
        },
        morph_eyes_str: {
            "0.0": 0.0,
            "0.4": 0.1,
            "0.8": 0.5,
            "1.0": 1.0
        },
        morph_nose_str: {
            "0.0": 0.0,
            "0.4": 0.2,
            "0.8": 0.6,
            "1.0": 1.0
        },
        skin_soft_str: {
            "0.0": 0.0,
            "0.4": 0.7,
            "0.8": 0.9,
            "1.0": 1.0
        },
        softlight_alpha: {
            "0.0": 0.0,
            "0.4": 0.7,
            "0.8": 1.0,
            "1.0": 1.0
        },
        eyes_coloring_str: {
            "0.0": 0.0,
            "0.4": 0.8,
            "0.8": 1.0,
            "1.0": 1.0
        }
    },

    softlight_textures: ["soft.ktx"],

    eyes_lut: "lut3d_eyes_verylow.png",

    teeth_highlight_lut : "lut3d_teeth_highlighter5.png",
};

var beautifyingProps = {
    morph_cheeks_str: 0.0,
    morph_eyes_str: 0.0,
    morph_nose_str: 0.0,

    skin_soft_str: 0.0,
    softlight_alpha: 0.0,
    softlight_tex: 0,

    eye_flare_alpha: 0.0,
    eyes_coloring_str: 0.0,

    teeth_whitening_str: 0.0,
    
    lashes_tex: 0,
    lashes_alpha: 0.0,

    eyebrows_tex: 0,
    eyebrows_alpha: 0.0,

    final_color_correction_str: 0.5,
};

/** ------ effect ------- **/

function Effect()
{
    var self = this;

    this.init = function() {
        var retouchMeshId = effectData.reservedMeshId.retouch;
        Api.meshfxMsg("spawn", retouchMeshId, 0, effectData.meshes.retouch);
        Api.showRecordButton();
        updateEffect();

        var makeupTypeShaderVarId = effectData.shadersIDs.makeupType;
        Api.meshfxMsg("shaderVec4", 0, makeupTypeShaderVarId, effectData.makeupsData.makeups["Empty"].type + " 0.0 0.0 0.0");

        var makeupTexId = effectData.retouchTexturesIDs.makeup;
        Api.meshfxMsg("tex", retouchMeshId, makeupTexId, effectData.makeupsData.makeups["Empty"].tex_name);

        var makeupApplyShaderVarId = effectData.shadersIDs.makeupApply;
        Api.meshfxMsg("shaderVec4", 0, makeupApplyShaderVarId, "0.0 0.0 0.0 0.0");
        
        Api.meshfxMsg("shaderVec4", 0, effectData.shadersIDs.platformData, 
        Api.getPlatform().toLowerCase() == "android" ? "0 0 0 0"  : "1 0 0 0" );

        testBeauty(1.0); // Enable beautification by default for testing

        initBackground("true");
        setBackgroundTexture("bg_alarm_tile.png");
    };

    this.restart = function() {
        Api.meshfxReset();
        self.init();
    };

    this.faceActions = [track_angle];
    this.noFaceActions = [];

    this.videoRecordStartActions = [];
    this.videoRecordFinishActions = [];
    this.videoRecordDiscardActions = [];
}

var effect = new Effect();

/* ------- each frame function -------- */

function forEachFrame(callback) {
    var deltalist = [16, 16, 16, 16, 16];
    var lastTime = new Date().getTime();
    effect.faceActions.push(frameCallback);
    effect.noFaceActions.push(frameCallback);

    function frameCallback() {
        var now = new Date().getTime();
        var delta = now - lastTime;
        lastTime = now;
        deltalist.unshift(delta);
        deltalist.pop();
        
        delta = average(deltalist);
        
        if(callback) {
            callback(delta, stopFunction);
        }
    }

    function stopFunction() {   
        var idx = effect.faceActions.indexOf(frameCallback);
        effect.faceActions.splice(idx, 1);
        idx = effect.noFaceActions.indexOf(frameCallback);
        effect.noFaceActions.splice(idx, 1);
    }
}

function average(arr) {
    return arr.reduce(function (prev, next) {
        return prev + next;
    }) / arr.length;
}

/** ----- makeup changing API ------ */

 function initMakeupChanging() {
    if (assertMakeupInitializing()) {
        effectData.makeupsData.isInitialized = true;
        var makeupApplyShaderVarId = effectData.shadersIDs.makeupApply;
        Api.meshfxMsg("shaderVec4", 0, makeupApplyShaderVarId, "1.0 0.0 0.0 0.0");
        Api.print("makeup changing initialized");
    }
 }

 function changeMakeup(name) {
    if (assertMakeupChanging(name)) {
        var retouchId = effectData.reservedMeshId.retouch;
        var makeupTexId = effectData.retouchTexturesIDs.makeup;
        var makeupTypeShaderVarId = effectData.shadersIDs.makeupType;

        Api.meshfxMsg("shaderVec4", 0, makeupTypeShaderVarId, effectData.makeupsData.makeups[name].type + " 0 0 0");
        Api.meshfxMsg("tex", retouchId, makeupTexId, effectData.makeupsData.makeups[name].tex_name);

        Api.print("changeMakeup - " + name + " makeup applied");
    } else {
        Api.print("changeMakeup - unable to change makeup");
    }
}

function assertMakeupInitializing() {
    if (effectData.makeupsData.isInitialized) {
        Api.print("cannot init already initialized makeups changing");
        return false;
    }

    return true;
}

function assertMakeupChanging(name) {
    if (!effectData.makeupsData.makeups[name]) {
        Api.print("assertMakeupChanging - invalid makeup name");
        return false;
    }

    if (!effectData.makeupsData.isInitialized) {
        Api.print("cannot change makeup if makeups changing in not initialized");
        return false;
    }

    return true;
}

function deleteMakeupChanging() {
    effectData.makeupsData.isInitialized = false;
    var makeupApplyShaderVarId = effectData.shadersIDs.makeupApply;
    Api.meshfxMsg("shaderVec4", 0, makeupApplyShaderVarId, "0.0 0.0 0.0 0.0");
}

/** ----- effect update ----- **/

function updateEffect() {  
    applySoftlightAlpha();  
    applySkinSofting();
    applysoftLight();
    applyCheeksMorphing();
    applyEyesMorphing();
    applyNoseMorphing();
    applyEyesColoring();
    applyTeethWhitening();
}

function interpolate(x1, fx1, x2, fx2, x) {
    return fx1 + (fx2 - fx1) * (x - x1) / (x2 - x1);
}

function interpolatedValue(param, value) {
    settings = effectData.interpolation[param];
    if (settings !== undefined) {
        if (value < 0.4) { // 0 - 40%
            return interpolate(0, settings["0.0"], 0.4, settings["0.4"], value);
        } else if (value < 0.8) {// 40 - 80%
            return interpolate(0.4, settings["0.4"], 0.8, settings["0.8"], value);
        } else { // 80 - 100%
            return interpolate(0.8, settings["0.8"], 1.0, settings["1.0"], value);
        }
    } else {
        return value;
    }
}

function track_angle() {
    var mv = Api.modelview();
    rot = Math.min(Math.max((mv[6] + 0.15) / (0.15 - 0.01), 0.0), 1.0);
    var skinSoftStr = beautifyingProps.skin_soft_str;
    var trackedValue = skinSoftStr + " 0.0 " + rot;
    var angleShaderVarId = effectData.shadersIDs.angle;
    Api.meshfxMsg("shaderVec4", 0, angleShaderVarId, trackedValue);
}

function applySkinSofting() {
    var skinSofStr = beautifyingProps.skin_soft_str;
    skinSofStr = interpolatedValue("skin_soft_str", skinSofStr);
    var shaderValue = skinSofStr + " 0.0 " + rot;
    var angleShaderVarId = effectData.shadersIDs.angle;
    Api.meshfxMsg("shaderVec4", 0, angleShaderVarId, shaderValue);
}

function applyCheeksMorphing() {
    var cheeksMorphStr = beautifyingProps.morph_cheeks_str;
    cheeksMorphStr = interpolatedValue("morph_cheeks_str", cheeksMorphStr);
    Api.meshfxMsg("beautyMorph", 0, cheeksMorphStr * 100, "face");
}

function applyEyesMorphing() {
    var eyesMorphStr = beautifyingProps.morph_eyes_str;
    eyesMorphStr = interpolatedValue("morph_eyes_str", eyesMorphStr);
    Api.meshfxMsg("beautyMorph", 0, eyesMorphStr * 200, "eyes");
}

function applyNoseMorphing() {
    var noseMorphStr = beautifyingProps.morph_nose_str;
    noseMorphStr = interpolatedValue("morph_nose_str", noseMorphStr);
    Api.meshfxMsg("beautyMorph", 0, noseMorphStr * 100, "nose");
}

function applysoftLight() {
    var softLightTexIdx = beautifyingProps.softlight_tex;
    var softLightTexture = effectData.softlight_textures[softLightTexIdx];

    var softTexId = effectData.retouchTexturesIDs.softLight;
    var retouchMatId = effectData.reservedMeshId.retouch;

    Api.meshfxMsg("tex", retouchMatId, softTexId, softLightTexture);
}

function applyEyesColoring() {
    var eyesColoringStr = beautifyingProps.eyes_coloring_str;
    eyesColoringStr = interpolatedValue("eyes_coloring_str", eyesColoringStr);

    var eyesColoringLutTex = effectData.eyes_lut;
    var eyesColoringLutPath = eyesColoringLutTex;

    Api.meshfxMsg("wlut", 1, eyesColoringStr * 50, eyesColoringLutPath);
}

function applyTeethWhitening() {
    var teethWhiteningStr = beautifyingProps.teeth_whitening_str * 100;
    var teetLutTexPath = effectData.teeth_highlight_lut;
    Api.meshfxMsg("wlut", 2, teethWhiteningStr, teetLutTexPath);
}

function applySoftlightAlpha() {
    var softlightAlpha =  beautifyingProps.softlight_alpha;
    softlightAlpha = interpolatedValue("softlight_alpha", softlightAlpha);

    var softLightVal = "0.0 " + softlightAlpha + " 0.0 0.0";
    var softlightAlphaShaderVarId = effectData.shadersIDs.softlightAlpha;

    Api.meshfxMsg("shaderVec4", 0, softlightAlphaShaderVarId, softLightVal);
}

/** ------- Additional functions --------- **/

function makeString() {
    return Array.prototype.join.call(arguments, arguments[arguments.length -1]);
}

function enableRecognizerFeature(feature) {
    if (effectData.recognizerData.activeRecognizers.indexOf(feature) >= 0) {
        Api.print("cannot set already established feature: " + feature);
        return;
    }

    effectData.recognizerData.activeRecognizers.push(feature);
    Api.setRecognizerFeatures(effectData.recognizerData.activeRecognizers);
}

function disableRecognizerFeature(feature) {
    var idx = effectData.recognizerData.activeRecognizers.indexOf(feature);

    if (idx >= 0)
        effectData.recognizerData.activeRecognizers.splice(idx, 1);

    Api.setRecognizerFeatures(effectData.recognizerData.activeRecognizers);
}

/**----------------- bg API -----------------**/

function initBackground(modifyRecognizerFeatures) {
    if (modifyRecognizerFeatures === 'true' && !effectData.recognizerData.initializedRecognizers.bg) {
        Api.print("initBackground background separation");

       enableRecognizerFeature("background");

        effectData.recognizerData.initializedRecognizers.bg = true;
    } else {
        Api.print(" - background separation is already enabled");
    }

    if (!effectData.meshesState.bgSeparationCreated) {
        Api.print("initBackground - add bg separation mesh");

        var id = effectData.reservedMeshId.bgSeparationMesh;
        var meshName = effectData.meshes.bgSeparation;
        Api.meshfxMsg("spawn", id, 0, meshName);

        effectData.meshesState.bgSeparationCreated = true;
    } else {
        Api.print("initBackground - cannot initialize already initialized bg mesh");
    }

    setBgRotation(effectData.bgState.currAngle);
    setBgScale(1);
}

function resetBgState() {
    effectData.bgState.bgScale = 1.0;
    effectData.bgState.currAngle = 0;
    setBgRotation(effectData.bgState.currAngle);
    setBgScale(effectData.bgState.bgScale);
}

function setBackgroundTexture(textureName) {
    if (!effectData.meshesState.bgSeparationCreated) {
        Api.print("cannot set bg texture because mesh is not created");
        return;
    }
    resetBgState();
    Api.meshfxMsg("tex", effectData.reservedMeshId.bgSeparationMesh, 0, textureName);
}

function rotateBg(angle) {
    effectData.bgState.currAngle += angle;
    setBgRotation(effectData.bgState.currAngle);
}

function scaleBg(scale) {
    effectData.bgState.currScale += scale;
    setBgScale(effectData.bgState.currScale);
}

function setBgRotation(angle) {
    if (!effectData.meshesState.bgSeparationCreated) {
        Api.print("cannot set bg rotation because mesh is not created");
        return;
    }

    Api.meshfxMsg("shaderVec4", 0, effectData.shadersIDs.bgRotation, angle + " 0 0 0");
}

function setBgScale(scale) {
    if (!effectData.meshesState.bgSeparationCreated) {
        Api.print("cannot set bg scale because mesh is not created");
        return;
    }

    Api.meshfxMsg("shaderVec4", 0, effectData.shadersIDs.bgScale, scale + " 0 0 0");
}

function deleteBackground(modifyRecognizerFeatures) {
    if (effectData.meshesState.bgSeparationCreated) {
        Api.print("deleteBackground - remove bg separation mesh");
        Api.meshfxMsg("del", effectData.reservedMeshId.bgSeparationMesh);
        effectData.meshesState.bgSeparationCreated = false;
    } else {
        Api.print("deleteBackground - cannot delete already deleted bg separation mesh");
    }

    if (modifyRecognizerFeatures === 'true' && effectData.recognizerData.initializedRecognizers.bg) {
        Api.print("deleteBackground - disable bg separation");
        effectData.recognizerData.initializedRecognizers.bg = false;

       disableRecognizerFeature("background");
    } else {
        Api.print("deleteBackground - bg separation is already disabled");
    }
}

/** ----- app callbacks ------- **/

function onRotationGesture(angle) {
    if (effectData.meshesState.bgSeparationCreated) {
        effectData.bgState.lastAngle = angle;
        setBgRotation(effectData.bgState.currAngle + effectData.bgState.lastAngle);
    }
}

function onScaleGesture(scale) {
    if (effectData.meshesState.bgSeparationCreated) {
        var currScale = scale;

        if (currScale < 1) {
            currScale= -(1. - currScale);
            if (effectData.bgState.bgScale + currScale > 0.1) {
                effectData.bgState.lastScale = currScale;
                setBgScale(effectData.bgState.bgScale + effectData.bgState.lastScale);
            }
        } else {
            effectData.bgState.lastScale = currScale - 1;
            setBgScale(effectData.bgState.bgScale + effectData.bgState.lastScale);
        }


    }
}

function onGestureEnded(name) {
    if (name === "Rotation") {
        effectData.bgState.currAngle += effectData.bgState.lastAngle;
    } else if (name === "Scale") {
        effectData.bgState.bgScale += effectData.bgState.lastScale;
    }
}

function onDataUpdate(param) {
    value = JSON.parse(param);

    if (typeof (value) == "object") {
        beautifyingProps = value;
        beautifyingProps.final_color_correction_str = 1.0;
        beautifyingProps.final_color_correction_tex = 0;
    } else {
        beautifyingProps.morph_cheeks_str = value;
        beautifyingProps.morph_eyes_str = value;
        beautifyingProps.morph_nose_str = value;

        beautifyingProps.skin_soft_str = value;
        beautifyingProps.softlight_alpha = value;
        beautifyingProps.softlight_tex = 0;

        beautifyingProps.eye_flare_alpha = 0.0;
        beautifyingProps.eyes_coloring_str = value;

        beautifyingProps.teeth_whitening_str = value;

        beautifyingProps.lashes_tex = 0;
        beautifyingProps.lashes_alpha = 0.0;
        
        beautifyingProps.eyebrows_tex = 0;
        beautifyingProps.eyebrows_alpha = 0.0;

        beautifyingProps.final_color_correction_str = 1.0;
        beautifyingProps.final_color_correction_tex = 0;
    }

    updateEffect();
}

/**
 * afer this function call beautyfication sould be set in value, wich argument receive 
 */
function testBeauty(value) {
    // initLutSlider();
    beautifyingProps = {
        morph_cheeks_str: value,
        morph_eyes_str: value,
        morph_nose_str: value,
    
        skin_soft_str: value,
        softlight_alpha: value,
        softlight_tex: 0,
    
        eye_flare_alpha: value,
        eyes_coloring_str: value,
    
        teeth_whitening_str: value,
    
        eyebrows_tex: 0,
        eyebrows_alpha: value,
    
        lashes_tex: 0,
        lashes_alpha: value,
    
        final_color_correction_str: value,
        final_color_correction_tex: 0,
    };

    updateEffect();
}

function timeOut(delay, callback) {
	var timer = new Date().getTime();

	effect.faceActions.push(removeAfterTimeOut);
	effect.noFaceActions.push(removeAfterTimeOut);

	function removeAfterTimeOut() {
        var now = new Date().getTime();
			
        if (now >= timer + delay) {
            var idx = effect.faceActions.indexOf(removeAfterTimeOut);
            effect.faceActions.splice(idx, 1);
            idx = effect.noFaceActions.indexOf(removeAfterTimeOut);
            effect.noFaceActions.splice(idx, 1);
            callback();
        }
	}
}

function testMakeups(currMake, delay) {
    initMakeupChanging();
    if (currMake >= effectData.makeupsData.makeups.length) {
        deleteMakeupChanging();
        return;
    }

    changeMakeup(currMake);

    timeOut(delay || 100, function() {
        testMakeups(currMake + 1, delay || 100);
    });
}

configure(effect);
